/*
 *  ZeX/OS
 *  Copyright (C) 2008  Tomas 'ZeXx86' Jedrzejek (zexx86@zexos.org)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <libx/base.h>
#include <libx/object.h>
#include <libx/image.h>
#include <libx/cursor.h>
#include <libx/text.h>

#include "cursor.h"

const unsigned char cursor_bitmap [] = {
	0x3f,0x3f,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x3f,0x3f,0x3f,0x3f,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0x3f,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0x3f,0x3f,0x3f,0xff,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0x3f,0xff,0xff,0xff,0x3f,0x00,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x00,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x00,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x00,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x00,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f
};


int draw_cursor ()
{
	int ret = xcursor_update ();

	int cur_x;
	int cur_y;

	xcursor_getpos (&cur_x, &cur_y);

	zde_cursor->x = cur_x;
	zde_cursor->y = cur_y;

	switch (ret) {
		case 0:
			zde_cursor->state = 0;
			break;
		case XCURSOR_STATE_RBUTTON:
			zde_cursor->state = XCURSOR_STATE_RBUTTON;
			break;
		case XCURSOR_STATE_LBUTTON:
			zde_cursor->state = XCURSOR_STATE_LBUTTON;
			break;
		case XCURSOR_STATE_BBUTTON:
			zde_cursor->state = XCURSOR_STATE_BBUTTON;
			break;
	}

	unsigned i = 0;
	unsigned j = 0;
	unsigned k = 0;
	for (i = 0; i < 15*15; i ++) {
		if (k >= 15) {
			j ++;
			k = 0;
		}

		if (cursor_bitmap[i] != 0xff)
			xpixel (zde_cursor->x+k, zde_cursor->y+j, cursor_bitmap[i]*256);

		k ++;
	}

	if (zde_cursor->state != XCURSOR_STATE_LBUTTON)
		zde_cursor->flags &= ~CURSOR_FLAG_LBCLICK;
	if (zde_cursor->state != XCURSOR_STATE_RBUTTON)
		zde_cursor->flags &= ~CURSOR_FLAG_RBCLICK;
	
	return 0;
}

int init_cursor ()
{
	zde_cursor = (zde_cursor_t *) malloc (sizeof (zde_cursor_t));

	if (!zde_cursor)
		return -1;

	zde_cursor->x = 0;
	zde_cursor->y = 0;
	zde_cursor->state = 0;
	zde_cursor->flags = 0;

	xcursor_settype (XCURSOR_MOUSE_AUTO);

	int ret = xcursor_init ();

	if (!ret)
		return -1;

	return 0;
}
